/*
  ab * cd ̌ʁAabcd 0xXXXXXXXXłf[^10TB

   bd mul22 ---> A
  ad0 mul12 ---> B
  cb0 mul21 ---> C
 ac00 mul11 ---> D
      addAB ---> E
      addCD ---> F
      addEF --->
      check

  RpC@Fgcc -fopenmp -o Program_1_M Source_Program_1_M.c
  
*/
#include <stdio.h>
#include <omp.h>
#define PATTERN (0x0ABCDEF00)	// 6  
#define COUNT   (10)
static struct {int a,b;} found[COUNT];
static unsigned int count=COUNT;

#define mul11() ( A = (a * c) << 16 )
#define mul12() ( B = (a * d) << 8 )
#define mul21() ( C = (c * b) << 8 )
#define mul22() ( D = (b * d) )
#define addAB() ( E = (A + B) )
#define addCD() ( F = (C + D) )
#define addEF() ( X = (E + F) )
#define check() ( !(X ^ PATTERN) )

void sub(unsigned int i)
{
  int a,b,c,d,A,B,C,D,E,F,X;
  unsigned int j;

  for ( j = 0 ; count && j <= 0xFFFF ; j++ )
  {
    a = i >> 8;		// 1oCgo(ӏ)
    b = i & 0xFF;	// 1oCgo(Ӊ)
    c = j >> 8;		// 1oCgo(Eӏ)
    d = j & 0xFF;	// 1oCgo(EӉ)
    mul22();		// ZP(ʁ~)
    mul12();		// ZQ(ʁ~) << 8
    mul21();		// ZR(ʁ~) << 8
    mul11();		// ZS(ʁ~) << 16
    addCD();		// ZP(ZP{ZR)
    addAB();		// ZQ(ZQ{ZS)
    addEF();		// ZR(ZP{ZQ)
    if( check() )
    {
#pragma omp critical(crit_val)
      {
	count--;
	found[count].a = i;
	found[count].b = j;
      }
      printf("%8.8X = %4.4X * %4.4X\n",X,i,j);
    }
  }
  return;
}
void main(void)
{
  unsigned int i;

#pragma omp parallel for
  for ( i = 0 ; i < 0xFFFF ; i++ )
    sub(i);

  return;
}
